Loading...
Searching...
No Matches
juce::OptionalScopedPointer< ObjectType > Class Template Reference

## Detailed Description

template<class ObjectType>
class juce::OptionalScopedPointer< ObjectType >

Holds a pointer to an object which can optionally be deleted when this pointer goes out of scope.

This acts in many ways like a std::unique_ptr, but allows you to specify whether or not the object is deleted.

The documentation for this class was generated from the following file:

- juce_core/memory/juce_OptionalScopedPointer.h

## Public Member Functions

| OptionalScopedPointer ()=default
| Creates an empty OptionalScopedPointer.
| OptionalScopedPointer (ObjectType *objectToHold, bool takeOwnership)
| Creates an OptionalScopedPointer to point to a given object, and specifying whether the OptionalScopedPointer will delete it.
| OptionalScopedPointer (OptionalScopedPointer &&other) noexcept
| Takes ownership of the object that another OptionalScopedPointer holds.
| OptionalScopedPointer (std::unique_ptr< ObjectType > &&ptr) noexcept
| Takes ownership of the object owned by ptr.
| OptionalScopedPointer (ObjectType &ref) noexcept
| Points to the same object as ref, but does not take ownership.
OptionalScopedPointer & | operator= (OptionalScopedPointer &&other) noexcept
| Takes ownership of the object that another OptionalScopedPointer holds.
| ~OptionalScopedPointer () noexcept
| The destructor may or may not delete the object that is being held, depending on the takeOwnership flag that was specified when the object was first passed into an OptionalScopedPointer constructor.
| operator ObjectType * () const noexcept
| Returns the object that this pointer is managing.
ObjectType * | get () const noexcept
| Returns the object that this pointer is managing.
ObjectType & | operator* () const noexcept
| Returns the object that this pointer is managing.
ObjectType * | operator-> () const noexcept
| Lets you access methods and properties of the object that this pointer is holding.
ObjectType * | release () noexcept
| Removes the current object from this OptionalScopedPointer without deleting it.
void | reset () noexcept
| Resets this pointer to null, possibly deleting the object that it holds, if it has ownership of it.
void | clear ()
| Does the same thing as reset().
void | set (ObjectType *newObject, bool takeOwnership)
| Makes this OptionalScopedPointer point at a new object, specifying whether the OptionalScopedPointer will take ownership of the object.
void | setOwned (ObjectType *newObject)
| Makes this OptionalScopedPointer point at a new object, and take ownership of that object.
void | setNonOwned (ObjectType *newObject)
| Makes this OptionalScopedPointer point at a new object, but will not take ownership of that object.
bool | willDeleteObject () const noexcept
| Returns true if the target object will be deleted when this pointer object is deleted.
void | swapWith (OptionalScopedPointer< ObjectType > &other) noexcept
| Swaps this object with another OptionalScopedPointer.

## Constructors and Destructors

## OptionalScopedPointer() [1/5]

template<class ObjectType>

juce::OptionalScopedPointer< ObjectType >::OptionalScopedPointer | ( |  | ) |

default

Creates an empty OptionalScopedPointer.

Referenced by operator=(), OptionalScopedPointer(), and swapWith().

## OptionalScopedPointer() [2/5]

template<class ObjectType>

juce::OptionalScopedPointer< ObjectType >::OptionalScopedPointer | ( | ObjectType * | objectToHold,
|  | bool | takeOwnership )

inline

Creates an OptionalScopedPointer to point to a given object, and specifying whether the OptionalScopedPointer will delete it.

If takeOwnership is true, then the OptionalScopedPointer will act like a std::unique_ptr, deleting the object when it is itself deleted. If this parameter is false, then the OptionalScopedPointer just holds a normal pointer to the object, and won't delete it.

## OptionalScopedPointer() [3/5]

template<class ObjectType>

juce::OptionalScopedPointer< ObjectType >::OptionalScopedPointer | ( | OptionalScopedPointer< ObjectType > && | other | ) |

inline noexcept

Takes ownership of the object that another OptionalScopedPointer holds.

Like a normal std::unique_ptr, the objectToTransferFrom object will become null, as ownership of the managed object is transferred to this object.

The flag to indicate whether or not to delete the managed object is also copied from the source object.

References OptionalScopedPointer().

## OptionalScopedPointer() [4/5]

template<class ObjectType>

juce::OptionalScopedPointer< ObjectType >::OptionalScopedPointer | ( | std::unique_ptr< ObjectType > && | ptr | ) |

inline explicit noexcept

Takes ownership of the object owned by ptr.

## OptionalScopedPointer() [5/5]

template<class ObjectType>

juce::OptionalScopedPointer< ObjectType >::OptionalScopedPointer | ( | ObjectType & | ref | ) |

inline explicit noexcept

Points to the same object as ref, but does not take ownership.

## ~OptionalScopedPointer()

template<class ObjectType>

juce::OptionalScopedPointer< ObjectType >::~OptionalScopedPointer | ( |  | ) |

inline noexcept

The destructor may or may not delete the object that is being held, depending on the takeOwnership flag that was specified when the object was first passed into an OptionalScopedPointer constructor.

References reset().

## Member Functions

## operator=()

template<class ObjectType>

OptionalScopedPointer & juce::OptionalScopedPointer< ObjectType >::operator= | ( | OptionalScopedPointer< ObjectType > && | other | ) |

inline noexcept

Takes ownership of the object that another OptionalScopedPointer holds.

Like a normal std::unique_ptr, the objectToTransferFrom object will become null, as ownership of the managed object is transferred to this object.

The ownership flag that says whether or not to delete the managed object is also copied from the source object.

References OptionalScopedPointer(), and swapWith().

## operator ObjectType *()

template<class ObjectType>

juce::OptionalScopedPointer< ObjectType >::operator ObjectType * | ( |  | ) | const

inline noexcept

Returns the object that this pointer is managing.

## get()

template<class ObjectType>

ObjectType * juce::OptionalScopedPointer< ObjectType >::get | ( |  | ) | const

inline noexcept

Returns the object that this pointer is managing.

Referenced by set().

## operator*()

template<class ObjectType>

ObjectType & juce::OptionalScopedPointer< ObjectType >::operator* | ( |  | ) | const

inline noexcept

Returns the object that this pointer is managing.

## operator->()

template<class ObjectType>

ObjectType * juce::OptionalScopedPointer< ObjectType >::operator-> | ( |  | ) | const

inline noexcept

Lets you access methods and properties of the object that this pointer is holding.

## release()

template<class ObjectType>

ObjectType * juce::OptionalScopedPointer< ObjectType >::release | ( |  | ) |

inline noexcept

Removes the current object from this OptionalScopedPointer without deleting it.

This will return the current object, and set this OptionalScopedPointer to a null pointer.

## reset()

template<class ObjectType>

void juce::OptionalScopedPointer< ObjectType >::reset | ( |  | ) |

inline noexcept

Resets this pointer to null, possibly deleting the object that it holds, if it has ownership of it.

Referenced by clear(), set(), and ~OptionalScopedPointer().

## clear()

template<class ObjectType>

void juce::OptionalScopedPointer< ObjectType >::clear | ( |  | ) |

inline

Does the same thing as reset().

References reset().

## set()

template<class ObjectType>

void juce::OptionalScopedPointer< ObjectType >::set | ( | ObjectType * | newObject,
|  | bool | takeOwnership )

inline

Makes this OptionalScopedPointer point at a new object, specifying whether the OptionalScopedPointer will take ownership of the object.

If takeOwnership is true, then the OptionalScopedPointer will act like a std::unique_ptr, deleting the object when it is itself deleted. If this parameter is false, then the OptionalScopedPointer just holds a normal pointer to the object, and won't delete it.

References get(), and reset().

Referenced by setNonOwned(), and setOwned().

## setOwned()

template<class ObjectType>

void juce::OptionalScopedPointer< ObjectType >::setOwned | ( | ObjectType * | newObject | ) |

inline

Makes this OptionalScopedPointer point at a new object, and take ownership of that object.

References set().

## setNonOwned()

template<class ObjectType>

void juce::OptionalScopedPointer< ObjectType >::setNonOwned | ( | ObjectType * | newObject | ) |

inline

Makes this OptionalScopedPointer point at a new object, but will not take ownership of that object.

References set().

## willDeleteObject()

template<class ObjectType>

bool juce::OptionalScopedPointer< ObjectType >::willDeleteObject | ( |  | ) | const

inline noexcept

Returns true if the target object will be deleted when this pointer object is deleted.

## swapWith()

template<class ObjectType>

void juce::OptionalScopedPointer< ObjectType >::swapWith | ( | OptionalScopedPointer< ObjectType > & | other | ) |

inline noexcept

Swaps this object with another OptionalScopedPointer.

The two objects simply exchange their states.

References OptionalScopedPointer().

Referenced by operator=().

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited